package cn.iocoder.yudao.module.member.service.activityawardsuser;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activityawardsuser.vo.ActivityAwardsUserCountVO;
import cn.iocoder.yudao.module.member.controller.admin.activityawardsuser.vo.ActivityAwardsUserPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.activityawardsuser.vo.ActivityAwardsUserRespVO;
import cn.iocoder.yudao.module.member.controller.admin.activityawardsuser.vo.ActivityAwardsUserSaveReqVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppCancelVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppUserAwardsVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activityawardsuser.ActivityAwardsUserDO;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
 * 活动中奖人员 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityAwardsUserService {

    /**
     * 创建活动中奖人员
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivityAwardsUser(@Valid ActivityAwardsUserSaveReqVO createReqVO);

    /**
     * 更新活动中奖人员
     *
     * @param updateReqVO 更新信息
     */
    void updateActivityAwardsUser(@Valid ActivityAwardsUserSaveReqVO updateReqVO);

    /**
     * 删除活动中奖人员
     *
     * @param id 编号
     */
    void deleteActivityAwardsUser(Long id);

    /**
     * 获得活动中奖人员
     *
     * @param id 编号
     * @return 活动中奖人员
     */
    ActivityAwardsUserDO getActivityAwardsUser(Long id);

    /**
     * 获得活动中奖人员分页
     *
     * @param pageReqVO 分页查询
     * @return 活动中奖人员分页
     */
    PageResult<ActivityAwardsUserDO> getActivityAwardsUserPage(ActivityAwardsUserPageReqVO pageReqVO);

    PageResult<ActivityAwardsUserRespVO> getActivityAwardsUserJoinPage(ActivityAwardsUserPageReqVO pageReqVO);

    Map<Long, ActivityAwardsUserCountVO> countByActivityIds(List<Long> activityIds);

    List<ActivityAwardsUserDO> getAwardsUserListByActivityId(Long activityId);

    void insertBatch(List<ActivityAwardsUserDO> list);

    List<AppUserAwardsVO> getListByActivityIdAndUserId(Long activityId, Long userId);

    Boolean cancel(AppCancelVO vo);

    List<ActivityAwardsUserDO> getListByTime();

    void updateBatch(List<ActivityAwardsUserDO> list );
}